-----------------------------------------------------------------------------------------------
-- Client Lua Script for Reload_redux
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- Reload_redux Module Definition
-----------------------------------------------------------------------------------------------
local Reload_redux = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function Reload_redux:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function Reload_redux:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- Reload_redux OnLoad
-----------------------------------------------------------------------------------------------
function Reload_redux:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("Reload_redux.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- Reload_redux OnDocLoaded
-----------------------------------------------------------------------------------------------
function Reload_redux:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "Reload_reduxForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("rui", "OnReload_reduxOn", self)
		Apollo.RegisterSlashCommand("rl", "OnReload_reduxOn", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- Reload_redux Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/rui"
function Reload_redux:OnReload_reduxOn()
	RequestReloadUI() -- show the window
end


-----------------------------------------------------------------------------------------------
-- Reload_reduxForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked


-----------------------------------------------------------------------------------------------
-- Reload_redux Instance
-----------------------------------------------------------------------------------------------
local Reload_reduxInst = Reload_redux:new()
Reload_reduxInst:Init()
